// Lambda2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <algorithm>
#include <functional>
#include <iostream>	
#include <vector>

using namespace std;
using namespace std::tr1;

void Foo()
{
	int a[3] = { 11, 12, 13 };

	vector<function<void(void)>> vf;

	// Store lambdas to print each element of an array
	int ctr;
	for (ctr = 0; ctr < 3; ++ctr) {
		vf.push_back([&]() {
			cout << "a[" << ctr << "] = " << a[ctr] << endl;
		});		
	}

	// Run each lambda
	for_each(begin(vf), end(vf), [](function<void(void)> f) {
		f();
	});
}

int _tmain(int argc, _TCHAR* argv[])
{
	Foo();

	cin.get();

	return 0;
}